//------------------------------------------------------------------
#property link      "www.forex-tsd.com"
#property copyright "www.forex-tsd.com mladen"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers    5
#property indicator_color1     DimGray
#property indicator_color2     LimeGreen
#property indicator_color3     PaleVioletRed
#property indicator_color4     LimeGreen
#property indicator_color5     PaleVioletRed
#property indicator_levelcolor DarkSlateGray
#property indicator_width1     1
#property indicator_width2     2
#property indicator_width3     2
#property indicator_minimum    -105
#property indicator_maximum    105

//
//
//
//
//

extern string TimeFrame        = "Current time frame";  
extern int    AroonPeriod      = 25;
extern int    Filter           = 50;

extern string Alerts_Settings  = "Settings for alerts";
extern bool   alertsOn         = false;
extern bool   alertsOnCurrent  = false;
extern bool   alertsMessage    = true;
extern bool   alertsSound      = false;
extern bool   alertsEmail      = false;

//
//
//
//
//

double osc[];
double osclu[];
double oscld[];
double oscau[];
double oscad[];
double trend[];

//
//
//
//
//

int    timeFrame;
string indicatorFileName;
bool   returnBars;
bool   calculateValue;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(6);
   SetIndexBuffer(0,osc);
   SetIndexBuffer(1,osclu);
   SetIndexBuffer(2,oscld);
   SetIndexBuffer(3,oscau); SetIndexStyle(3,DRAW_ARROW); SetIndexArrow(3,108);
   SetIndexBuffer(4,oscad); SetIndexStyle(4,DRAW_ARROW); SetIndexArrow(4,108);
   SetIndexBuffer(5,trend);
      SetLevelValue(0, Filter);
      SetLevelValue(1,-Filter);
      
      //
      //
      //
      //
      //
      
         indicatorFileName = WindowExpertName();
         calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
         returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
         timeFrame         = stringToTimeFrame(TimeFrame);
      
      //
      //
      //
      //
      //
      
   IndicatorShortName(timeFrameToString(timeFrame)+" Aroon oscillator ("+AroonPeriod+")");
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int limit,i,counted_bars = IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
       limit = MathMin(Bars - counted_bars,Bars-1);
       if (returnBars) { osc[0] = limit+1; return(0); }

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame == Period())
   {
     for(i = limit; i >= 0 ; i--)
     {  
        double AroonUp = 100.0*(AroonPeriod-iHighest(NULL,0,MODE_HIGH,AroonPeriod+1,i)+i)/AroonPeriod;
        double AroonDn = 100.0*(AroonPeriod- iLowest(NULL,0,MODE_LOW ,AroonPeriod+1,i)+i)/AroonPeriod;
           osc[i] = AroonUp-AroonDn;
           osclu[i] = EMPTY_VALUE;
           oscld[i] = EMPTY_VALUE;
           oscau[i] = EMPTY_VALUE;
           oscad[i] = EMPTY_VALUE;
           trend[i] = trend[i+1];
              if (osc[i] >  Filter)                     trend[i] =  1;
              if (osc[i] < -Filter)                     trend[i] = -1;
              if (osc[i] <  Filter && osc[i] > -Filter) trend[i] = 0;
              if (trend[i] == 1)
              {
                 osclu[i] = osc[i]; if (trend[i]!=trend[i+1]) oscau[i] = osc[i];
              }
              if (trend[i] == -1)
              {
                 oscld[i] = osc[i]; if (trend[i]!=trend[i+1]) oscad[i] = osc[i];
              }
   }
   manageAlerts();
   return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit;i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         osc[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",AroonPeriod,Filter,0,y);
         osclu[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",AroonPeriod,Filter,1,y);
         oscld[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",AroonPeriod,Filter,2,y);
         trend[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",AroonPeriod,Filter,5,y);
         oscau[i] = EMPTY_VALUE;
         oscad[i] = EMPTY_VALUE;
            if (osclu[i]!= EMPTY_VALUE && osclu[i+1] == EMPTY_VALUE) oscau[i] = osclu[i];
            if (oscld[i]!= EMPTY_VALUE && oscld[i+1] == EMPTY_VALUE) oscad[i] = oscld[i];            
   }
   manageAlerts();  
   return(0);         
}


//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M10","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,10,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}

//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
            int forBar = 0;
      else      forBar = 1; forBar = iBarShift(NULL,0,iTime(NULL,timeFrame,forBar));
      
      //
      //
      //
      //
      //

      if (oscau[forBar]!= EMPTY_VALUE) doAlert("trend chaned to UP");
      if (oscad[forBar]!= EMPTY_VALUE) doAlert("trend chaned to DOWN");
   }       
}

//----------------------------------------------------------------------------------
//
//----------------------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[0]) {
       previousAlert  = doWhat;
       previousTime   = Time[0];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," - ",timeFrameToString(timeFrame)+"Aroon oscillator",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail("Aroon oscillator",message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

